/* bbrbss Copyright (C) 1999-2001 by Stacey Keast <slik@telusplanet.net>
**
** This program is free software; you can redistribut it and/or modify it
** (please do) under the terms of the GNU General Public License as published
** by the Free Software Foundation; either version 2 of the License, or (at
** your option) any later version.
**
** This program is distributed in the hope that it will be useful, but
** WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
** or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
** for more details.
**
** You should have received a copy of the GNU General Public License along with
** this program; if not, write to the Free Software Foundation, Inc.,
** 675 Mass Ave, Cambridge, MA 02139, USA.
**
** (See the included file COPYING / GPL-2.0)
*/

#include "updatestyle.h"

void
updatestyle (char *rootcommand)
{
  updatestyle_reset_no (rootcommand);
  resetBB ();
}

void
updatestyle_reset_no (char *rootcommand)
{
  char *blackboxrc, *currentstyleFile, *home;
  char styleFile[1024] = "";
  home = getenv ("HOME");
  blackboxrc = malloc (strlen (home) + 13);
  strcpy (blackboxrc, home);
  strcat (blackboxrc, "/.blackboxrc");
  currentstyleFile = malloc (strlen (home) + 31);
  getcurrentstyle (currentstyleFile);

  /* file,field,arg -  must free arg after use. */
  if (getarg (blackboxrc, "session.styleFile", styleFile))
    {
      resetBB ();
      getarg (blackboxrc, "session.styleFile", styleFile);
    }

  if (strcmp (styleFile, currentstyleFile) != 0)
    {
      copyfile (currentstyleFile, styleFile);
      /* file,field,arg */
      setarg (blackboxrc, "session.styleFile", currentstyleFile);
    }
  /* file,field,arg */
  setarg (currentstyleFile, "rootCommand", rootcommand);

  free (blackboxrc);
  /*  free(styleFile); */
  free (currentstyleFile);
}
